package gitpb

// does processing on the go.mod and go.sum files

import (
	"go.wit.com/log"
)

func (repo *Repo) setRepoState() {
	if repo == nil {
		return
	}
	if repo.IsDirty() {
		repo.State = "dirty"
		return
	}
	if repo.GetUserVersion() != repo.GetDevelVersion() {
		repo.State = "merge to devel"
		return
	}
	if repo.GetDevelVersion() != repo.GetMasterVersion() {
		repo.State = "merge to main"
		return
	}
	if repo.GetLastTag() != repo.GetMasterVersion() {
		repo.State = "unchanged"
		return
	}

	if repo.CheckBranches() {
		repo.State = "PERFECT"
		return
	}
	log.Info("Branches are not Perfect", repo.GetFullPath())
	log.Info("Branches are not Perfect", repo.GetFullPath())
	log.Info("Branches are not Perfect", repo.GetFullPath())
	repo.State = "unknown branches"
}
